; ASTRO version 1.0
;  Benjamin Moody
;  benjamin@ecg.mit,edu

;------------------------------------------------
;  Memory/AppVar Routines
;------------------------------------------------

; In future, allow reading data without deleting from fROM?

CheckCreateAV:
    ld hl,AppVarSym
    call Mov9ToOP1
    B_CALL _ChkFindSym
    jr c,CreateAV       ; If it doesn't exist, create it
    ld a,b
    or a    ; is the page zero (RAM)?
    jr nz,UnArcAV   ; is it in fROM? if so, move to RAM first
    inc de
    inc de
    ld (AVstart),de
    ret

DelCreateAV:
    ld hl,AppVarSym
    call Mov9ToOP1
    B_CALL _ChkFindSym  ; find it again
    B_CALL _DelVarArc   ; delete it
    ld hl,AppVarName
    call Mov9ToOP1
CreateAV:
    ld hl,AVLength
    B_CALL _CreateAppVar
    inc de              ; leave 2 bytes for length
    inc de
    ld (AVstart),de
    ld hl,DefaultAV
    ld bc,AVLength
    ldir                ; copy in defaults
    ret
UnArcAV:
    B_CALL _Arc_Unarc   ; move to RAM
    B_CALL _ChkFindSym  ; Get new location
    inc de
    inc de
    ld (AVstart),de
    ret

BadAV:
    ; *Invalid*AppVar*
    ; 1:Replace
    ; 2:Quit
    
    B_CALL _ClrLCDFull
    ld hl,0
    ld (curRow),hl
    ld hl,InvalidAVStr
    set textInverse,(iy+textFlags)
    call PutS
    ld hl,1
    ld (curRow),hl
    ld hl,Replace1Str
    res textInverse,(iy+textFlags)
    call PutS
    ld hl,2
    ld (curRow),hl
    ld hl,Quit2Str
    call PutS
BadAVmenu:
    B_CALL _GetKey
    cp k1
    jr z,DelCreateAV
    cp k2
    jp z,QuitNow
    jr BadAVmenu
    
LoadAppVar:
    ; Check name and version
    ld hl,(AVstart)
    ld bc,DefaultAV
    ld d,5
CheckAVloop:
    ld a,(bc)       ; Check to see that 5 byte signature is
    cp (hl)         ; equal to that in DefaultAV
    jr nz,BadAV
    inc bc
    inc hl
    dec d
    ld a,d
    or a
    jr nz,CheckAVloop

    inc hl ; Should check to see if version less or equal
    inc hl
    ld de,StoredData
    ld bc,AVLength-7
    ldir
    ret

SaveAppVar:
    ld de,(AVstart)
    inc de
    inc de
    inc de
    inc de
    inc de
    inc de
    inc de
    ld hl,StoredData
    ld bc,AVLength-7
    ldir
    ret

.end
END