
; ASTRO version 1.0
;  Benjamin Moody
;  benjamin@ecg.mit,edu

;------------------------------------------------
;  * * *   D A T A   * * *
;------------------------------------------------

;------- Strings -------
AppVarSym:
    .db AppVarObj
AppVarName:
    .db "Astro",0,0,0,0
InvalidAVStr:
    .db " Invalid AppVar ",0
Replace1Str:
    .db "1:Replace",0
Quit2Str:
    .db "2:Quit",0
NameLbl:
    .db "Astro 1.0",0
StrObjScreen:
    .db " Select Objects ",0
SunStr:
    .db "Sun           ",0
MoonStr:
    .db "Moon          ",0
PlanetsStr:
    .db "Planets       ",0
Stars0Str:
    .db "Stars         ",0
LocScrnStr:
    .db "  Set Location  ",0
LocScrnTxtStr:
    .db "Longitude:      "
    .db "    ",Ldegree,"  '        "
    .db "Latitude:       "
    .db "    ",Ldegree,"  '        "
    .db 0
TimeScrnStr:
    .db "    Set Time    ",0
TimeScrnTxtStr:
    .db "Date:   /  /    "
    .db "Time:   :       "
    .db "Time Zone       "
    .db 0

ObjStrs:
    .dw SunStr
    .dw MoonStr
    .dw PlanetsStr
    .dw Stars0Str

;------- Float Constants -------

floatDay2Deg:
    .db $00,$7f,$98,$56,$46,$52,$25,$15,$86
floatZeroTime:
    .db $00,$82,$10,$04,$60,$00,$00,$00,$00
float15:
    .db $00,$81,$15,$00,$00,$00,$00,$00,$00
floatpt5:
    .db $00,$7f,$50,$00,$00,$00,$00,$00,$00
float90:
    .db $00,$81,$90,$00,$00,$00,$00,$00,$00
float31:
    .db $00,$81,$31,$00,$00,$00,$00,$00,$00
float48:
    .db $00,$81,$48,$00,$00,$00,$00,$00,$00
float24:
    .db $00,$81,$24,$00,$00,$00,$00,$00,$00

;------- Month Table -------

Months:
    .dw 0
    .dw 31
    .dw 31+28
    .dw 31+28+31
    .dw 31+28+31+30
    .dw 31+28+31+30+31
    .dw 31+28+31+30+31+30
    .dw 31+28+31+30+31+30+31
    .dw 31+28+31+30+31+30+31+31
    .dw 31+28+31+30+31+30+31+31+30
    .dw 31+28+31+30+31+30+31+31+30+31
    .dw 31+28+31+30+31+30+31+31+30+31+30

;------- Compass Rose Sprite -------

RoseSpr:
    .db 17,16
    .db %00000000, %11000000
    .db %00000000, %10100000
    .db %00000000, %10100000
    .db %00000000, %10100000
    .db %00000000, %10100000
    .db %00000000, %00000000
    .db %00011100, %01000101
    .db %00010000, %01000101
    .db %00011001, %11110101
    .db %00010000, %01000111
    .db %00011100, %01000101
    .db %00000000, %00000000
    .db %00000000, %01100000
    .db %00000000, %10000000
    .db %00000000, %01000000
    .db %00000000, %00100000
    .db %00000000, %11000000

RoseSprEnd:
;------- App Monitor Signals -------
AppVectors:
    .dw nothing
    .dw nothing
    .dw QuitKey
    .dw nothing
    .dw nothing
    .dw nothing
    .db appTextSaveF
nothing:
    ret     ; optimize: use a ret already used in program

;------- Default Configuration -------
; Default AppVar Configuration

; Note that this is in the same order
; as it is stored in StatVars
;  This is necessary for the Loading
;  and Saving routines

; Default: London, January 1, 2000, noon, full sky, stars 3-
;  all new objects on
DefaultAV:
    .db "Astro"
    .dw Version
; Location
    .db 0,0   ; Longitude
    .db 30,51 ; Latitude
    .db 0,0   ; target azimuth
    .db 0,90  ; target altitude
    .db 1     ; magnification
; Time
    .db 0     ; second
    .db 0     ; minute
    .db 0     ; hour
    .db 1     ; day
    .db 1     ; month
    .dw 2000  ; year
    .db 0     ; time zone
; Objects
    .db 30   ; star max magnitude
    .db 4     ; NumObjs
    .db $ff,$ff,$ff,0,0,0,0,0,0,0,0,0 ; ObjectsOn
    .db AppVarObj,"--------"
    .db AppVarObj,"--------"
    .db AppVarObj,"--------"
    .db AppVarObj,"--------"
    .db AppVarObj,"--------"
    .db AppVarObj,"--------"
    .db AppVarObj,"--------"
    .db AppVarObj,"--------"

DefaultAVend:
