
; ASTRO version 1.0
;  Benjamin Moody
;  benjamin@ecg.mit,edu

;------------------------------------------------
;  Greek Letters
;------------------------------------------------

PutGreekChar:
    ld d,a
    ld h,0
    ld l,a
    ld bc,GreekChars
    add hl,bc
    ld a,(hl)
    or a
    jr z,PutGreekSprite
    B_CALL _PutMap
    ret
PutGreekSprite:
    ld h,0
    ld l,d
    ld bc,GreekChars
    add hl,bc
    ld l,(hl)
    ld h,0
    ld bc,GreekSpriteOffset
    add hl,bc
    ld de,SpriteMem
    ld bc,58
    ldir
    ld de,(curRow)
    sla d           ; Multiply d by 8
    sla d
    sla d
    ld a,e          ; Multiply e by 6
    add a,e
    add a,e
    ld e,a
    sla e
    ld hl,SpriteMem
    B_CALL _DisplayImage
    ret
    
GreekChars:
    .db Lalpha
    .db Lbeta
    .db Lgamma
    .db Ldelta
    .db Lepsilon
    .db 0 ;zeta
    .db 0 ;eta
    .db Ltheta
    .db 0 ;iota
    .db 0 ;kappa
    .db Llambda
    .db Lmu
    .db 0 ;nu
    .db 0 ;xi
    .db "o"
    .db Lpi
    .db Lrho
    .db Lsigma
    .db Ltau
    .db 0 ;upsilon
    .db Lphi
    .db Lchi
    .db 0 ;psi
    .db 0 ;omega

GreekSpriteOffset:
    .db 0
    .db 0
    .db 0
    .db 0
    .db 0
    .db sZeta-GS
    .db sEta-GS
    .db 0
    .db sIota-GS
    .db sKappa-GS
    .db 0
    .db 0
    .db sNu-GS
    .db sXi-GS
    .db 0
    .db 0
    .db 0
    .db 0
    .db 0
    .db sUpsilon-GS
    .db 0
    .db 0
    .db sPsi-GS
    .db sOmega-GS

;------- Sprites -------
GS:
sZeta:
    .db 7,5
    .db %01000000
    .db %00111000
    .db %01000000
    .db %10000000
    .db %01110000
    .db %00001000
    .db %00110000
sEta:
    .db 7,5
    .db %00000000
    .db %00000000
    .db %10000000
    .db %01110000
    .db %01001000
    .db %01001000
    .db %00001000
sIota:
    .db 7,5
    .db %00000000
    .db %00000000
    .db %01000000
    .db %01000000
    .db %01000000
    .db %01010000
    .db %00100000
sKappa:
    .db 7,5
    .db %00000000
    .db %00000000
    .db %10010000
    .db %10100000
    .db %11000000
    .db %10100000
    .db %10010000
sNu:
    .db 7,5
    .db %00000000
    .db %00000000
    .db %10001000
    .db %01001000
    .db %01010000
    .db %00100000
    .db %00100000
sXi:
    .db 7,5
    .db %01000000
    .db %00110000
    .db %01000000
    .db %00110000
    .db %01000000
    .db %00110000
    .db %00010000
sUpsilon:
    .db 7,5
    .db %00000000
    .db %00000000
    .db %11001000
    .db %01001000
    .db %01001000
    .db %01001000
    .db %00110000
sPsi:
    .db 7,5
    .db %00000000
    .db %00100000
    .db %10101000
    .db %10101000
    .db %01110000
    .db %00100000
    .db %00100000
sOmega:
    .db 7,5
    .db %00000000
    .db %00000000
    .db %01010000
    .db %10001000
    .db %10101000
    .db %10101000
    .db %01010000

.end
END