
; ASTRO version 1.0
;  Benjamin Moody
;  benjamin@ecg.mit,edu

;------------------------------------------------
;  LOCATION SCREEN
;------------------------------------------------

LocationScreen:
    B_CALL _ClrLCDFull
    ld hl,0
    ld (curRow),hl
    set textInverse,(iy+textFlags)
    ld hl,LocScrnStr
    call PutS
    res textInverse,(iy+textFlags)
    ld hl,LocScrnTxtStr
    call PutS
    xor a
    ld (MenuSelect),a
    ld (MenuSelect2),a
    ld (MenuStart),a    ; used as flag for number entry.
LocScreenLoop:
    call DrawLocScreen
    B_CALL _ApdSetup
    B_CALL _GetKey
    res apdRunning,(iy+apdFlags)
    cp kQuit
    jp z,MainScreen
    cp kDown
    jr z,LocScrDn
    cp kUp
    jr z,LocScrUp
    cp kLeft
    jr z,LocScrLt
    cp kRight
    jr z,LocScrRt
    jp nz,LocScrNumKey
    jr LocScreenLoop

LocScrDn:
    ld a,(MenuSelect)
    cp 1                ; if already at bottom
    jr z,LocScreenLoop
    inc a
    ld (MenuSelect),a
    xor a
    ld (MenuSelect2),a
    ld (MenuStart),a
    jr LocScreenLoop

LocScrUp:
    ld a,(MenuSelect)
    or a                ; if already at top
    jr z,LocScreenLoop
    dec a
    ld (MenuSelect),a
    xor a
    ld (MenuSelect2),a
    ld (MenuStart),a
    jr LocScreenLoop

LocScrLt:
    ld a,(MenuSelect2)
    or a
    jr z,LocScreenLoop
    dec a
    ld (MenuSelect2),a
    xor a
    ld (MenuStart),a
    jr LocScreenLoop

LocScrRt:
    ld a,(MenuSelect2)
    cp 2
    jr z,LocScreenLoop
    inc a
    ld (MenuSelect2),a
    xor a
    ld (MenuStart),a
    jr LocScreenLoop


LocScrChgDir:
    ld a,(MenuSelect)
    or a
    jr nz,LocScrChgDirLat
    ld a,(ViewLng)
    xor %10000000
    ld (ViewLng),a
    jp LocScreenLoop
LocScrChgDirLat:
    ld a,(ViewLat)
    xor %10000000
    ld (ViewLat),a
    jp LocScreenLoop


LocScrNumKey:
    ld d,a
    ld a,(MenuSelect2)
    cp 2
    jr z,LocScrChgDir
    or a
    jr nz,LocScrNumKeyMins
LocScrNumKeyDegs:
    ld a,(MenuSelect)
    or a
    jr z,LocScrNumKeyDegLng
LocScrNumKeyDegLat:
    ld hl,ViewLat+1
    jr LocScrNumKeyCnt2
LocScrNumKeyDegLng:
    ld hl,ViewLng+1
    jr LocScrNumKeyCnt2
LocScrNumKeyMins:
    ld a,(MenuSelect)
    or a
    jr z,LocScrNumKeyMinLng
LocScrNumKeyMinLat:
    ld hl,ViewLat
    jr LocScrNumKeyCnt2
LocScrNumKeyMinLng:
    ld hl,ViewLng
LocScrNumKeyCnt2:
    ld a,(MenuStart)
    or a
    jr nz,LocScrNumKeyCnt
    inc a
    ld (MenuStart),a
    ld (hl),0
LocScrNumKeyCnt:
    ld a,d
    cp kDel
    jr z,LocScrNumKeyDel
    cp kClear
    jr z,LocScrNumKeyClr
    cp k0
    jp c,LocScreenLoop
    cp k9+1
    jp nc,LocScreenLoop
    sub k0
    ld b,a
    ld a,(hl)
    cp 19
    jp nc,LocScreenLoop
    cp 6
    jr nc,LocScrNumKeyCk2
LocScrNumKeyCnt3:
    sla a
    ld c,a
    sla a
    sla a
    add a,c
    add a,b
    ld (hl),a
    jp LocScreenLoop
LocScrNumKeyDel:
LocScrNumKeyClr:
    ld (hl),0
    jp LocScreenLoop
LocScrNumKeyCk2:
    ld d,a
    ld a,(MenuSelect2)
    or a
    jp nz,LocScreenLoop
    ld a,d
    jr LocScrNumKeyCnt3
    
DrawLocScreen:
    ld hl,0*256+1
    ld (curRow),hl
    ld hl,LocScrnTxtStr
    call PutS

    ld hl,1*256+2
    ld (curRow),hl
    ld a,(MenuSelect)
    or a
    jr nz,DLSLng1Cnt
    ld a,(MenuSelect2)
    or a
    jr nz,DLSLng1Cnt
    set textInverse,(iy+textFlags)
DLSLng1Cnt:
    ld a,(ViewLng+1)
    call Put3DecNum
    res textInverse,(iy+textFlags)

    ld hl,5*256+2
    ld (curRow),hl
    ld a,(MenuSelect)
    or a
    jr nz,DLSLng2Cnt
    ld a,(MenuSelect2)
    cp 1
    jr nz,DLSLng2Cnt
    set textInverse,(iy+textFlags)
DLSLng2Cnt:
    ld a,(ViewLng)
    and %00111111
    call Put2DecNum
    res textInverse,(iy+textFlags)

    ld hl,9*256+2
    ld (curRow),hl
    ld a,(MenuSelect)
    or a
    jr nz,DLSLngDCnt
    ld a,(MenuSelect2)
    cp 2
    jr nz,DLSLngDCnt
    set textInverse,(iy+textFlags)
DLSLngDCnt:
    ld a,(ViewLng)
    bit 7,a
    jr nz,DLSLngDCnt2
    ld a,'E'
    jr DLSLngDCnt3
DLSLngDCnt2:
    ld a,'W'
DLSLngDCnt3:
    B_CALL _PutC
    res textInverse,(iy+textFlags)

    ld hl,1*256+4
    ld (curRow),hl
    ld a,(MenuSelect)
    cp 1
    jr nz,DLSLat1Cnt
    ld a,(MenuSelect2)
    or a
    jr nz,DLSLat1Cnt
    set textInverse,(iy+textFlags)
DLSLat1Cnt:
    ld a,(ViewLat+1)
    call Put3DecNum
    res textInverse,(iy+textFlags)

    ld hl,5*256+4
    ld (curRow),hl
    ld a,(MenuSelect)
    cp 1
    jr nz,DLSLat2Cnt
    ld a,(MenuSelect2)
    cp 1
    jr nz,DLSLat2Cnt
    set textInverse,(iy+textFlags)
DLSLat2Cnt:
    ld a,(ViewLat)
    and %00111111
    call Put2DecNum
    res textInverse,(iy+textFlags)

    ld hl,9*256+4
    ld (curRow),hl
    ld a,(MenuSelect)
    cp 1
    jr nz,DLSLatDCnt
    ld a,(MenuSelect2)
    cp 2
    jr nz,DLSLatDCnt
    set textInverse,(iy+textFlags)
DLSLatDCnt:
    ld a,(ViewLat)
    bit 7,a
    jr nz,DLSLatDCnt2
    ld a,'N'
    jr DLSLatDCnt3
DLSLatDCnt2:
    ld a,'S'
DLSLatDCnt3:
    B_CALL _PutC
    res textInverse,(iy+textFlags)

    ret

    