
; ASTRO version 1.0
;  Benjamin Moody
;  benjamin@ecg.mit,edu

;------------------------------------------------
;  Math Routines
;------------------------------------------------

CalcAbsDay:
    ld hl,(ViewYear)
    or a
    ld bc,2000
    sbc hl,bc
    jr nc,CAbsDayCnt1
    or a
    ld hl,2000
    ld bc,(ViewYear)
    sbc hl,bc
    B_CALL _SetXXXXOP2
    B_CALL _OP2ToOP1
    call FPNegate
    jr CAbsDayCnt2
CAbsDayCnt1:
    B_CALL _SetXXXXOP2
    B_CALL _OP2ToOP1
CAbsDayCnt2:
    ld hl,floatpt5
    call Mov9ToOP2
    rst rFPAdd
    ld de,ViewAbsDay
    B_CALL _MovFrOP1
    
    ld bc,(ViewMinute)
    call HMToFloat
    ld hl,float24
    call Mov9ToOP2
    B_CALL _FPDiv
    ld hl,ViewAbsDay
    B_CALL _Mov9ToOP2
    rst rFPAdd

    ld a,(ViewMDay)
    dec a
    ld c,a
    ld b,0
    add hl,bc
        
    ld a,(ViewMonth)
    or a
    cp 3
    jr c,CAbsDayCnt3
    inc hl
CAbsDayCnt3:
    dec a
    ld hl,Months
    ld c,a
    ld b,0
    add hl,bc
    ld b,(hl)
    inc hl
    ld c,(hl)
    ld h,b
    ld l,c
    B_CALL _SetXXXXOP2
    rst rFPAdd
    ret

CalcViewAngles:
    call CalcAbsDay
    ld hl,floatDay2Deg
    call Mov9ToOP2
    B_CALL _FPMult
    B_CALL _OP1ToOP6
    ld bc,(ViewMinute)
    call HMToFloat
    ld hl,float15
    call Mov9ToOP2
    B_CALL _FPMult  
    B_CALL _OP6ToOP2
    rst rFPAdd
    B_CALL _OP1ToOP6
    ld bc,(ViewLng)
    call DMToFloat
    B_CALL _OP6ToOP2
    rst rFPAdd
    ld hl,floatZeroTime
    call Mov9ToOP2
    rst rFPAdd
    ld de,ViewRA_f
    B_CALL _MovFrOP1

    ld bc,(ViewLat)
    call DMToFloat
    ld de,ViewDec_f
    B_CALL _MovFrOP1

    ret


CalcStar:
    ; OP1 = declination
    ; OP2 = right ascension
    ld de,StarDec_f
    B_CALL _MovFrOP1
    ld hl,float15
    call Mov9ToOP1
    B_CALL _FPMult
    ld hl,ViewRA_f
    call Mov9ToOP2
    B_CALL _FPSub
    call FPNegate
    ld de,StarRA_f
    B_CALL _MovFrOP1
    
    B_CALL _Cos
    B_CALL _OP1ToOP6
    ld hl,ViewDec_f
    rst rMov9ToOP1
    B_CALL _Cos
    B_CALL _OP6ToOP2
    B_CALL _FPMult
    B_CALL _OP1ToOP6
    ld hl,StarDec_f
    rst rMov9ToOP1
    B_CALL _Cos
    B_CALL _OP6ToOP2
    B_CALL _FPMult
    rst rPushRealO1
    
    ld hl,ViewDec_f
    rst rMov9ToOP1
    B_CALL _Sin
    B_CALL _OP1ToOP6
    ld hl,StarDec_f
    rst rMov9ToOP1
    B_CALL _Sin
    B_CALL _OP6ToOP2
    B_CALL _FPMult
    B_CALL _PopRealO2
    rst rFPAdd
    B_CALL _ASin
    rst rPushRealO1     ; FPS[alt
    
    B_CALL _Sin
    B_CALL _OP1ToOP6
    ld hl,ViewDec_f
    rst rMov9ToOP1
    B_CALL _Sin
    B_CALL _OP6ToOP2
    B_CALL _FPMult
    B_CALL _OP1ToOP6
    ld hl,StarDec_f
    rst rMov9ToOP1
    B_CALL _Sin
    B_CALL _OP6ToOP2
    B_CALL _FPSub
    B_CALL _OP1ToOP6
    B_CALL _PopRealO1
    rst rPushRealO1
    B_CALL _Cos
    rst rOP1ToOP2
    B_CALL _OP6ToOP1
    B_CALL _FPDiv
    B_CALL _OP1ToOP6
    ld hl,ViewDec_f
    rst rMov9ToOP1
    B_CALL _Cos
    rst rOP1ToOP2
    B_CALL _OP6ToOP1
    B_CALL _FPDiv
    B_CALL _ACos
    B_CALL _OP1ToOP6
    ld hl,StarRA_f
    rst rMov9ToOP1
    B_CALL _Sin
    B_CALL _CkOP1Pos
    jr z,CalcStar1
    B_CALL _OP6ToOP1
    call FPNegate
    ret
CalcStar1:
    B_CALL _OP6ToOP1
    ret

DeclRtAscStr:
    .db "Decl, RtAsc:    ",0


;------Math Utility Routines

HMToFloat:
    ; BC: ---hhhhh
    ;     --mmmmmm
    ld a,c
    push bc
    B_CALL _SetXXOP1
    B_CALL _OP2Set60
    B_CALL _FPDiv
    pop bc
    ld a,b
    B_CALL _SetXXOP2
    rst rFPAdd
    ret    

DMToFloat:
    ; BC: dddddddd
    ;     s-mmmmmm
    ; s being the angle direction.
    ;
    ; Returns: OP1 = degrees
    ld a,c
    and %00111111
    push bc
    B_CALL _SetXXOP1
    B_CALL _OP2Set60
    B_CALL _FPDiv
    pop bc
    push bc
    ld a,b
    or a
    cp 99
    jr c,DM2FCnt
    sub 99
    push af
    ld a,99
    B_CALL _SetXXOP2
    rst rFPAdd
    pop af
DM2FCnt:
    B_CALL _SetXXOP2
    rst rFPAdd
    pop bc
    bit 7,c
    ret z
FPNegate:
    ld a,(OP1)
    xor %10000000
    ld (OP1),a
    ret

; When dealing with Trigonometric Functions:

PresOP25:
    B_CALL _PushRealO2
    B_CALL _PushRealO3
    B_CALL _PushRealO4
    B_CALL _PushRealO5
    ret
RetOP25:
    B_CALL _PopRealO5
    B_CALL _PopRealO4
    B_CALL _PopRealO3
    B_CALL _PopRealO2
    ret

.end
END