
; ASTRO version 1.0
;  Benjamin Moody
;  benjamin@ecg.mit,edu

;------------------------------------------------
;  OBJECTS SCREEN
;------------------------------------------------

ObjectsScreen:
    B_CALL _ClrLCDFull
    set textInverse,(iy+textFlags)
    ld hl,$0000
    ld (curRow),hl
    ld hl,StrObjScreen
    call PutS
    res textInverse,(iy+textFlags)
    xor a
    ld (MenuStart),a
    ld (MenuSelect),a
ObjectsScreenLoop:
    call DrawObjectScreen
ObjScrKeyLoop:
    B_CALL _ApdSetup
    B_CALL _GetKey
    res apdRunning,(iy+apdFlags)
    
    jr z,ObjScrKeyLoop
    ld (LastKey),a
    cp kDown
    call z,ObjScrDn
    ld a,(LastKey)
    cp kUp
    call z,ObjScrUp
    ld a,(LastKey)
    cp kEnter
    call z,ObjScrChg
    ld a,(LastKey)
    cp kQuit
    jp z,MainScreen
    jr ObjectsScreenLoop

ObjScrDn:
    ld a,(MenuSelect)
    inc a
    ld (MenuSelect),a
    ld b,a
    ld a,(NumObjs)
    cp b
    jr z,ObjScrLoopDn
    ld a,(MenuStart)
    ld b,a
    ld a,(MenuSelect)
    sub b
    cp 7
    call z,ObjScrMovDn
    ret

ObjScrUp:
    ld a,(MenuSelect)
    sub 1              ; Why?  Because dec doesn't set the carry flag so
    jr c,ObjScrLoopUp  ;  I'd need a cp 255, 11 cycles as opposed to 7
    ld (MenuSelect),a
    ld b,a
    ld a,(MenuStart)
    dec a
    cp b
    call z,ObjScrMovUp
    ret

ObjScrLoopDn:
    xor a
    ld (MenuSelect),a
    xor a
    ld (MenuStart),a
    ret

ObjScrLoopUp:
    ld a,(NumObjs)
    dec a
    ld (MenuSelect),a
    ld a,(NumObjs)
    cp 7
    ret c
    sub 7
    ld (MenuStart),a
    ret

ObjScrMovDn:
    ld a,(MenuStart)
    inc a
    ld (MenuStart),a
    ret

ObjScrMovUp:
    ld a,(MenuStart)
    dec a
    ld (MenuStart),a
    ret   

ObjScrChg:
    ld a,(MenuSelect)
    ld e,a
    ld d,0
    ld hl,ObjectsOn
    add hl,de
    ld a,(hl)
    cpl
    ld (hl),a
    ret

DrawObjectScreen:
    ld d,1
    ld a,(MenuStart)
    ld e,a

DrawObjScrLoop:
    ld a,e
    ld b,a
    ld a,(NumObjs)
    cp b
    ret z
    ld a,d
    cp 8
    ret z
    ld (curRow),a
    xor a
    ld (curCol),a

    ld bc,ObjectsOn
    ld h,0
    ld l,e
    add hl,bc
    ld a,(hl)
    or a
    jr nz,ObjScrNotSel
ObjScrSel:
    ld a,(MenuSelect)
    cp e
    jr z,ObjScrSelCur
ObjScrSelNC:
    ld a,Lblock
    jr ObjScrChrCont
ObjScrSelCur:
    ld a,LblockArrow
    jr ObjScrChrCont
ObjScrNotSel:
    ld a,(MenuSelect)
    cp e
    jr z,ObjScrNSCur
ObjScrNSNC:
    ld a,32
    jr ObjScrChrCont
ObjScrNSCur:
    ld a,Lconvert

ObjScrChrCont:
    B_CALL _PutC    ; All of that's to draw the first character! Aren't we proud?
    ld a,32
    B_CALL _PutC    ; Add another space

    ld bc,ObjStrs
    ld h,0
    ld l,e
    sla l           ; 2 bytes per address (note: Only allows 128 strings)

    add hl,bc
    ld a,(hl)
    inc hl
    ld b,(hl)
    ld l,a
    ld h,b
    call PutS
    inc e
    inc d
    jr DrawObjScrLoop

.end
END