
; ASTRO version 1.0
;  Benjamin Moody
;  benjamin@ecg.mit,edu

;------------------------------------------------
;  TIME SCREEN
;------------------------------------------------

TimeScreen:
    B_CALL _ClrLCDFull
    set textInverse,(iy+textFlags)
    ld hl,0
    ld (curRow),hl
    ld hl,TimeScrnStr
    call PutS
    res textInverse,(iy+textFlags)
    ld hl,TimeScrnTxtStr
    call PutS
    xor a
    ld (MenuSelect),a
    ld (MenuSelect2),a
    call DrawTimeScreen
TimeScreenLoop:
    call ReDrawTimeScreen
    B_CALL _ApdSetup
    B_CALL _GetKey
    res apdRunning,(iy+apdFlags)
    cp kQuit
    jp z,MainScreen
    cp kDown
    jr z,TimeScrDn
    cp kUp
    jr z,TimeScrUp
    cp kLeft
    jr z,TimeScrLt
    cp kRight
    jr z,TimeScrRt
    cp kAdd
    jr z,TimeScrAdd
    cp kSub
    jp z,TimeScrSub
    jr TimeScreenLoop

TimeScrDn:
    ld a,(MenuSelect)
    cp 2                ; if already at bottom
    jr z,TimeScreenLoop
    inc a
    ld (MenuSelect),a
    xor a
    ld (MenuSelect2),a
    jr TimeScreenLoop

TimeScrUp:
    ld a,(MenuSelect)
    or a                ; if already at top
    jr z,TimeScreenLoop
    dec a
    ld (MenuSelect),a
    xor a
    ld (MenuSelect2),a
    jr TimeScreenLoop

TimeScrLt:
    ld a,(MenuSelect2)
    or a
    jr z,TimeScreenLoop
    dec a
    ld (MenuSelect2),a
    jr TimeScreenLoop

TimeScrRt:
    or a
    ld a,(MenuSelect)
    ld b,a
    ld a,2
    sub b
    ld b,a
    ld a,(MenuSelect2)
    cp b
    jr nc,TimeScreenLoop
    inc a
    ld (MenuSelect2),a
    jr TimeScreenLoop

TimeScrAdd:
    ld a,(MenuSelect)
    cp 2
    jr z,TSTZAdd
    cp 1
    jr z,TSTimeAdd
TSDateAdd:
    ld a,(MenuSelect2)
    or a
    jr z,TSMonthAdd
    cp 1
    jr z,TSDayAdd
TSYearAdd:
    ld hl,(ViewYear)
    inc hl
    ld (ViewYear),hl
    jp TimeScreenLoop
TSMonthAdd:
    ld a,(ViewMonth)
    cp 12
    jp z,TimeScreenLoop
    inc a
    ld (ViewMonth),a
    jp TimeScreenLoop
TSDayAdd:
    ld a,(ViewMDay)
    cp 31
    jp z,TimeScreenLoop
    inc a
    ld (ViewMDay),a
    jp TimeScreenLoop

TSTimeAdd:
    ld a,(MenuSelect2)
    or a
    jp z,TSHourAdd
TSMinuteAdd:
    ld a,(ViewMinute)
    cp 59
    jp z,TimeScreenLoop
    inc a
    ld (ViewMinute),a
    jp TimeScreenLoop
TSHourAdd:
    ld a,(ViewHour)
    cp 23
    jp z,TSHour0
    inc a
    ld (ViewHour),a
    jp TimeScreenLoop
TSHour0:
    xor a
    ld (ViewHour),a
    jp TimeScreenLoop

TSTZAdd:
    ld a,(ViewTZ)
    cp 23
    jp z,TSTZ0
    inc a
    ld (ViewTZ),a
    jp TimeScreenLoop
TSTZ0:
    xor a
    ld (ViewTZ),a
    jp TimeScreenLoop


TimeScrSub:
    ld a,(MenuSelect)
    cp 2
    jr z,TSTZSub
    cp 1
    jr z,TSTimeSub
TSDateSub:
    ld a,(MenuSelect2)
    or a
    jr z,TSMonthSub
    cp 1
    jr z,TSDaySub
TSYearSub:
    ld hl,(ViewYear)
    dec hl
    ld (ViewYear),hl
    jp TimeScreenLoop
TSMonthSub:
    ld a,(ViewMonth)
    cp 1
    jp z,TimeScreenLoop
    dec a
    ld (ViewMonth),a
    jp TimeScreenLoop
TSDaySub:
    ld a,(ViewMDay)
    cp 1
    jp z,TimeScreenLoop
    dec a
    ld (ViewMDay),a
    jp TimeScreenLoop

TSTimeSub:
    ld a,(MenuSelect2)
    or a
    jp z,TSHourSub
TSMinuteSub:
    ld a,(ViewMinute)
    or a
    jp z,TimeScreenLoop
    dec a
    ld (ViewMinute),a
    jp TimeScreenLoop
TSHourSub:
    ld a,(ViewHour)
    or a
    jr z,TSHour23
    dec a
    ld (ViewHour),a
    jp TimeScreenLoop
TSHour23:
    ld a,23
    ld (ViewHour),a
    jp TimeScreenLoop

TSTZSub:
    ld a,(ViewTZ)
    or a
    jr z,TSTZ23
    dec a
    ld (ViewTZ),a
    jp TimeScreenLoop
TSTZ23:
    ld a,23
    ld (ViewTZ),a
    jp TimeScreenLoop



DrawTimeScreen:
    ld hl,0*256+1
    ld (curRow),hl
    ld hl,TimeScrnTxtStr
    call PutS

ReDrawTimeScreen:
    ld hl,6*256+1
    ld (curRow),hl
    ld a,(MenuSelect)
    or a
    jr nz,DTSMonthCnt
    ld a,(MenuSelect2)
    or a
    jr nz,DTSMonthCnt
    set textInverse,(iy+textFlags)
DTSMonthCnt:
    ld a,(ViewMonth)
    call Put2DecNum
    res textInverse,(iy+textFlags)
    
    ld hl,9*256+1
    ld (curRow),hl
    ld a,(MenuSelect)
    or a
    jr nz,DTSDayCnt
    ld a,(MenuSelect2)
    cp 1
    jr nz,DTSDayCnt
    set textInverse,(iy+textFlags)
DTSDayCnt:
    ld a,(ViewMDay)
    call Put2DecNum
    res textInverse,(iy+textFlags)
    
    ld hl,12*256+1
    ld (curRow),hl
    ld a,(MenuSelect)
    or a
    jr nz,DTSYearCnt
    ld a,(MenuSelect2)
    cp 2
    jr nz,DTSYearCnt
    set textInverse,(iy+textFlags)
DTSYearCnt:
    ld hl,(ViewYear)
    call Put4DecNum
    res textInverse,(iy+textFlags)

    ld hl,6*256+2
    ld (curRow),hl
    ld a,(MenuSelect)
    cp 1
    jr nz,DTSHourCnt
    ld a,(MenuSelect2)
    or a
    jr nz,DTSHourCnt
    set textInverse,(iy+textFlags)
DTSHourCnt:
    ld a,(ViewHour)
    call Put2DecNum
    res textInverse,(iy+textFlags)

    ld hl,9*256+2
    ld (curRow),hl
    ld a,(MenuSelect)
    cp 1
    jr nz,DTSMinCnt
    ld a,(MenuSelect2)
    cp 1
    jr nz,DTSMinCnt
    set textInverse,(iy+textFlags)
DTSMinCnt:
    ld a,(ViewMinute)
    call Put2DecNum
    res textInverse,(iy+textFlags)

    ld hl,10*256+3
    ld (curRow),hl
    ld a,(MenuSelect)
    cp 2
    jr nz,DTSTZCnt
    set textInverse,(iy+textFlags)
DTSTZCnt:
    ld a,(ViewTZ)
    call Put2DecNum
    res textInverse,(iy+textFlags)

    res preClrForMode,(iy+newDispF)
    ret

Put2DecNum:
    ld b,'0'
    or a
Put2DNLp:
    cp 10
    jr c, Put2DNCnt
    sub 10
    inc b
    jr Put2DNLp
Put2DNCnt:
    ld c,a
    ld a,b
    B_CALL _PutC
    ld a,c
    ld b,'0'
    add a,b
    B_CALL _PutC
    ret

Put4DecNum:
    ld b,0
Put4DNLp:
    ld a,h
    or a
    jr nz,Put4DNCnt1
    ld a,l
    cp 100
    jr c, Put4DNCnt2
Put4DNCnt1:
    ld de,100
    sbc hl,de
    inc b
    jr Put4DNLp
Put4DNCnt2:
    push af
    ld a,b
    call Put2DecNum
    pop af
    call Put2DecNum
    ret

Put3DecNum:
    ld b,'0'
Put3DNLp:
    cp 100
    jr c, Put3DNCnt2
    sub 100
    inc b
    jr Put3DNLp
Put3DNCnt2:
    push af
    ld a,b
    B_CALL _PutC
    pop af
    call Put2DecNum
    ret
